SeededKnnVectorQuery (Lucene 10.5.0 core API)
Description: declaration: package: org.apache.lucene.search, class: SeededKnnVectorQuery

Package org.apache.lucene.search

# Class SeededKnnVectorQuery

java.lang.Object
org.apache.lucene.search.Query
org.apache.lucene.search.SeededKnnVectorQuery

public class SeededKnnVectorQuery extends Query
This is a version of knn vector query that provides a query seed to initiate the vector search. NOTE: The underlying format is free to ignore the provided seed

See "Lexically-Accelerated Dense Retrieval" (Kulkarni, Hrishikesh and MacAvaney, Sean and Goharian, Nazli and Frieder, Ophir). In SIGIR '23: Proceedings of the 46th International ACM SIGIR Conference on Research and Development in Information Retrieval Pages 152 - 162

WARNING: This API is experimental and might change in incompatible ways in the next release.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected final String`
  `field`
  `protected final Query`
  `filter`
  `protected final int`
  `k`
  `protected final KnnSearchStrategy`
  `searchStrategy`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `SeededKnnVectorQuery(KnnByteVectorQuery knnQuery, Query seed, Weight seedWeight)`
  `SeededKnnVectorQuery(KnnFloatVectorQuery knnQuery, Query seed, Weight seedWeight)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected TopDocs`
  `approximateSearch(LeafReaderContext context, AcceptDocs acceptDocs, int visitedLimit, KnnCollectorManager knnCollectorManager)`
  `boolean`
  `equals(Object o)`
  Override and implement query instance equivalence properly in a subclass.
  `protected TopDocs`
  `exactSearch(LeafReaderContext context, DocIdSetIterator acceptIterator, QueryTimeout queryTimeout)`
  `static SeededKnnVectorQuery`
  `fromByteQuery(KnnByteVectorQuery knnQuery, Query seed)`
  Construct a new SeededKnnVectorQuery instance for a byte vector field
  `static SeededKnnVectorQuery`
  `fromFloatQuery(KnnFloatVectorQuery knnQuery, Query seed)`
  Construct a new SeededKnnVectorQuery instance for a float vector field
  `String`
  `getField()`
  `Query`
  `getFilter()`
  `int`
  `getK()`
  `protected KnnCollectorManager`
  `getKnnCollectorManager(int k, IndexSearcher searcher)`
  `KnnSearchStrategy`
  `getSearchStrategy()`
  `int`
  `hashCode()`
  Override and implement query hash code properly in a subclass.
  `protected TopDocs`
  `mergeLeafResults(TopDocs[] perLeafResults)`
  Merges all segment-level kNN results to get the index-level kNN results.
  `Query`
  `rewrite(IndexSearcher indexSearcher)`
  Expert: called to re-write queries into primitive queries.
  `protected TopDocs`
  `searchLeaf(LeafReaderContext ctx, Weight filterWeight, TimeLimitingKnnCollectorManager timeLimitingKnnCollectorManager)`
  `String`
  `toString(String field)`
  Prints a query to a string, with `field` assumed to be the default field and omitted.
  `void`
  `visit(QueryVisitor visitor)`
  Recurse through the query tree, visiting any child queries.

  ### Methods inherited from class org.apache.lucene.search.Query

  `classHash, createWeight, sameClassAs, toString`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### field

    protected final String field

  - ### k

    protected final int k

  - ### filter

    protected final Query filter

  - ### searchStrategy

    protected final KnnSearchStrategy searchStrategy

- ## Constructor Details

  - ### SeededKnnVectorQuery

    public SeededKnnVectorQuery(KnnFloatVectorQuery knnQuery, Query seed, Weight seedWeight)

  - ### SeededKnnVectorQuery

    public SeededKnnVectorQuery(KnnByteVectorQuery knnQuery, Query seed, Weight seedWeight)

- ## Method Details

  - ### fromFloatQuery

    public static SeededKnnVectorQuery fromFloatQuery(KnnFloatVectorQuery knnQuery, Query seed)
    Construct a new SeededKnnVectorQuery instance for a float vector field
    Parameters:
      `knnQuery` - the knn query to be seeded
      `seed` - a query seed to initiate the vector format search
    Returns:
      a new SeededKnnVectorQuery instance
    WARNING: This API is experimental and might change in incompatible ways in the next release.

  - ### fromByteQuery

    public static SeededKnnVectorQuery fromByteQuery(KnnByteVectorQuery knnQuery, Query seed)
    Construct a new SeededKnnVectorQuery instance for a byte vector field
    Parameters:
      `knnQuery` - the knn query to be seeded
      `seed` - a query seed to initiate the vector format search
    Returns:
      a new SeededKnnVectorQuery instance
    WARNING: This API is experimental and might change in incompatible ways in the next release.

  - ### toString

    public String toString(String field)
    Description copied from class: `Query`
    Prints a query to a string, with `field` assumed to be the default field and omitted.
    Specified by:
      `toString` in class `Query`

  - ### rewrite

    public Query rewrite(IndexSearcher indexSearcher) throws IOException
    Description copied from class: `Query`
    Expert: called to re-write queries into primitive queries. For example, a PrefixQuery will be rewritten into a BooleanQuery that consists of TermQuerys.

    Callers are expected to call `rewrite` multiple times if necessary, until the rewritten query is the same as the original query.

    The rewrite process may be able to make use of IndexSearcher's executor and be executed in parallel if the executor is provided.

    Throws:
      `IOException`
    See Also:
      - `IndexSearcher.rewrite(Query)`

  - ### approximateSearch

    protected TopDocs approximateSearch(LeafReaderContext context, AcceptDocs acceptDocs, int visitedLimit, KnnCollectorManager knnCollectorManager) throws IOException
    Throws:
      `IOException`

  - ### getKnnCollectorManager

    protected KnnCollectorManager getKnnCollectorManager(int k, IndexSearcher searcher)

  - ### exactSearch

    protected TopDocs exactSearch(LeafReaderContext context, DocIdSetIterator acceptIterator, QueryTimeout queryTimeout) throws IOException
    Throws:
      `IOException`

  - ### mergeLeafResults

    protected TopDocs mergeLeafResults(TopDocs[] perLeafResults)
    Merges all segment-level kNN results to get the index-level kNN results.

    The default implementation delegates to `TopDocs.merge(int, TopDocs[])` to find the overall top `k`, which requires input results to be sorted.

    This method is useful for reading and / or modifying the final results as needed.

    Parameters:
      `perLeafResults` - array of segment-level kNN results.
    Returns:
      index-level kNN results (no constraint on their ordering).

  - ### visit

    public void visit(QueryVisitor visitor)
    Description copied from class: `Query`
    Recurse through the query tree, visiting any child queries.
    Parameters:
      `visitor` - a QueryVisitor to be called by each query in the tree

  - ### equals

    public boolean equals(Object o)
    Description copied from class: `Query`
    Override and implement query instance equivalence properly in a subclass. This is required so that `QueryCache` works properly.

    Typically a query will be equal to another only if it's an instance of the same class and its document-filtering properties are identical to those of the other instance. Utility methods are provided for certain repetitive code.

    See Also:
      - `Query.sameClassAs(Object)`
      - `Query.classHash()`

  - ### hashCode

    public int hashCode()
    Description copied from class: `Query`
    Override and implement query hash code properly in a subclass. This is required so that `QueryCache` works properly.
    See Also:
      - `Query.equals(Object)`

  - ### getField

    public String getField()
    Returns:
      the knn vector field where the knn vector search happens.

  - ### getK

    public int getK()
    Returns:
      the max number of results the KnnVector search returns.

  - ### getFilter

    public Query getFilter()
    Returns:
      the filter that is executed before the KnnVector search happens. Only the results accepted by this filter are returned by the KnnVector search.

  - ### searchLeaf

    protected TopDocs searchLeaf(LeafReaderContext ctx, Weight filterWeight, TimeLimitingKnnCollectorManager timeLimitingKnnCollectorManager) throws IOException
    Throws:
      `IOException`

  - ### getSearchStrategy

    public KnnSearchStrategy getSearchStrategy()